//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		załanczane biblioteki

#include <iostream>

//#include <cmath>				// <-- biblioteka z funkcjami matematycznymi c++, rozszeżenie biblioteki math.h

//#include <vector>				// <-- biblioteka wektorów

//#include <fstream>				// <-- biblioteka strumieni związanych z plikami

//#include <string>				// <-- biblioteka napisów


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%		clasa 
// Rycerz
//
//


class Rycerz
{

private:

	int dx;
	int dy;

	double kat;

public:

	// Są to zmienne dostępne poza klasą.
	
	int x;
	int y;
	
	int punkt_docelowy_x = 0;
	int punkt_docelowy_y = 0;
	int pozwolenie_na_marsz = 0;
	int nie_wykonano_zmiany_pozycji = 0;

	int poz_x;
	int poz_y;
	
	int next_poz_x;
	int next_poz_y;
	
	
	int kierunek;

	int wybrany;


	BITMAP *atak_wschod_0;
	BITMAP *atak_wschod_1;
	BITMAP *atak_wschod_2;
	BITMAP *atak_wschod_3;
	BITMAP *atak_wschod_4;
	BITMAP *atak_wschod_5;
	BITMAP *atak_wschod_6;
	BITMAP *atak_wschod_7;
	BITMAP *atak_wschod_8;
	BITMAP *atak_wschod_9;
	BITMAP *atak_wschod_10;
	BITMAP *atak_wschod_11;
	BITMAP *atak_wschod_12;

	BITMAP *atak_zachod_0;
	BITMAP *atak_zachod_1;
	BITMAP *atak_zachod_2;
	BITMAP *atak_zachod_3;
	BITMAP *atak_zachod_4;
	BITMAP *atak_zachod_5;
	BITMAP *atak_zachod_6;
	BITMAP *atak_zachod_7;
	BITMAP *atak_zachod_8;
	BITMAP *atak_zachod_9;
	BITMAP *atak_zachod_10;
	BITMAP *atak_zachod_11;
	BITMAP *atak_zachod_12;

	BITMAP *atak_polnoc_0;
	BITMAP *atak_polnoc_1;
	BITMAP *atak_polnoc_2;
	BITMAP *atak_polnoc_3;
	BITMAP *atak_polnoc_4;
	BITMAP *atak_polnoc_5;
	BITMAP *atak_polnoc_6;
	BITMAP *atak_polnoc_7;
	BITMAP *atak_polnoc_8;
	BITMAP *atak_polnoc_9;
	BITMAP *atak_polnoc_10;
	BITMAP *atak_polnoc_11;
	BITMAP *atak_polnoc_12;

	BITMAP *atak_poludnie_0;
	BITMAP *atak_poludnie_1;
	BITMAP *atak_poludnie_2;
	BITMAP *atak_poludnie_3;
	BITMAP *atak_poludnie_4;
	BITMAP *atak_poludnie_5;
	BITMAP *atak_poludnie_6;
	BITMAP *atak_poludnie_7;
	BITMAP *atak_poludnie_8;
	BITMAP *atak_poludnie_9;
	BITMAP *atak_poludnie_10;
	BITMAP *atak_poludnie_11;
	BITMAP *atak_poludnie_12;


	BITMAP *atak_polnoc_wschod_0;
	BITMAP *atak_polnoc_wschod_1;
	BITMAP *atak_polnoc_wschod_2;
	BITMAP *atak_polnoc_wschod_3;
	BITMAP *atak_polnoc_wschod_4;
	BITMAP *atak_polnoc_wschod_5;
	BITMAP *atak_polnoc_wschod_6;
	BITMAP *atak_polnoc_wschod_7;
	BITMAP *atak_polnoc_wschod_8;
	BITMAP *atak_polnoc_wschod_9;
	BITMAP *atak_polnoc_wschod_10;
	BITMAP *atak_polnoc_wschod_11;
	BITMAP *atak_polnoc_wschod_12;

	BITMAP *atak_poludnie_wschod_0;
	BITMAP *atak_poludnie_wschod_1;
	BITMAP *atak_poludnie_wschod_2;
	BITMAP *atak_poludnie_wschod_3;
	BITMAP *atak_poludnie_wschod_4;
	BITMAP *atak_poludnie_wschod_5;
	BITMAP *atak_poludnie_wschod_6;
	BITMAP *atak_poludnie_wschod_7;
	BITMAP *atak_poludnie_wschod_8;
	BITMAP *atak_poludnie_wschod_9;
	BITMAP *atak_poludnie_wschod_10;
	BITMAP *atak_poludnie_wschod_11;
	BITMAP *atak_poludnie_wschod_12;

	BITMAP *atak_poludnie_zachod_0;
	BITMAP *atak_poludnie_zachod_1;
	BITMAP *atak_poludnie_zachod_2;
	BITMAP *atak_poludnie_zachod_3;
	BITMAP *atak_poludnie_zachod_4;
	BITMAP *atak_poludnie_zachod_5;
	BITMAP *atak_poludnie_zachod_6;
	BITMAP *atak_poludnie_zachod_7;
	BITMAP *atak_poludnie_zachod_8;
	BITMAP *atak_poludnie_zachod_9;
	BITMAP *atak_poludnie_zachod_10;
	BITMAP *atak_poludnie_zachod_11;
	BITMAP *atak_poludnie_zachod_12;

	BITMAP *atak_polnoc_zachod_0;
	BITMAP *atak_polnoc_zachod_1;
	BITMAP *atak_polnoc_zachod_2;
	BITMAP *atak_polnoc_zachod_3;
	BITMAP *atak_polnoc_zachod_4;
	BITMAP *atak_polnoc_zachod_5;
	BITMAP *atak_polnoc_zachod_6;
	BITMAP *atak_polnoc_zachod_7;
	BITMAP *atak_polnoc_zachod_8;
	BITMAP *atak_polnoc_zachod_9;
	BITMAP *atak_polnoc_zachod_10;
	BITMAP *atak_polnoc_zachod_11;
	BITMAP *atak_polnoc_zachod_12;


public:

// ################################################################################# konstruktor:


	Rycerz()
	{
		wybrany = 0;
		kierunek = 2;
		wczytanie_obrazkow();
	}

	Rycerz(int x_init, int y_init)
	{
		kierunek = 1;
		wczytanie_obrazkow();

		poz_x = x_init;
		poz_y = y_init;
		
		punkt_docelowy_x = x_init; // pozycja docelowa na starcie taka jak podczas tworzenia obiektu
		punkt_docelowy_y = y_init;

		x = poz_x - 48;
		y = poz_y - 48;
	}

	Rycerz(int x_init, int y_init, int kierunek_int)
	{
		kierunek = kierunek_int;
		wczytanie_obrazkow();

		poz_x = x_init;
		poz_y = y_init;
		
		punkt_docelowy_x = x_init; // pozycja docelowa na starcie taka jak podczas tworzenia obiektu
		punkt_docelowy_y = y_init;

		x = poz_x - 48;
		y = poz_y - 48;
	}

void wczytanie_obrazkow()
{

  atak_wschod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0000.bmp",default_palette);
  atak_wschod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0001.bmp",default_palette);
  atak_wschod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0002.bmp",default_palette);
  atak_wschod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0003.bmp",default_palette);
  atak_wschod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0004.bmp",default_palette);
  atak_wschod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0005.bmp",default_palette);
  atak_wschod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0006.bmp",default_palette);
  atak_wschod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0007.bmp",default_palette);
  atak_wschod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0008.bmp",default_palette);
  atak_wschod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0009.bmp",default_palette);
  atak_wschod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0010.bmp",default_palette);
  atak_wschod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0011.bmp",default_palette);
  atak_wschod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack e0012.bmp",default_palette);




  atak_polnoc_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0000.bmp",default_palette);
  atak_polnoc_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0001.bmp",default_palette);
  atak_polnoc_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0002.bmp",default_palette);
  atak_polnoc_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0003.bmp",default_palette);
  atak_polnoc_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0004.bmp",default_palette);
  atak_polnoc_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0005.bmp",default_palette);
  atak_polnoc_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0006.bmp",default_palette);
  atak_polnoc_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0007.bmp",default_palette);
  atak_polnoc_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0008.bmp",default_palette);
  atak_polnoc_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0009.bmp",default_palette);
  atak_polnoc_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0010.bmp",default_palette);
  atak_polnoc_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0011.bmp",default_palette);
  atak_polnoc_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack n0012.bmp",default_palette);



  atak_poludnie_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0000.bmp",default_palette);
  atak_poludnie_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0001.bmp",default_palette);
  atak_poludnie_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0002.bmp",default_palette);
  atak_poludnie_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0003.bmp",default_palette);
  atak_poludnie_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0004.bmp",default_palette);
  atak_poludnie_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0005.bmp",default_palette);
  atak_poludnie_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0006.bmp",default_palette);
  atak_poludnie_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0007.bmp",default_palette);
  atak_poludnie_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0008.bmp",default_palette);
  atak_poludnie_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0009.bmp",default_palette);
  atak_poludnie_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0010.bmp",default_palette);
  atak_poludnie_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0011.bmp",default_palette);
  atak_poludnie_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack s0012.bmp",default_palette);


  atak_zachod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0000.bmp",default_palette);
  atak_zachod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0001.bmp",default_palette);
  atak_zachod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0002.bmp",default_palette);
  atak_zachod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0003.bmp",default_palette);
  atak_zachod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0004.bmp",default_palette);
  atak_zachod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0005.bmp",default_palette);
  atak_zachod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0006.bmp",default_palette);
  atak_zachod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0007.bmp",default_palette);
  atak_zachod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0008.bmp",default_palette);
  atak_zachod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0009.bmp",default_palette);
  atak_zachod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0010.bmp",default_palette);
  atak_zachod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0011.bmp",default_palette);
  atak_zachod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack w0012.bmp",default_palette);

  atak_polnoc_zachod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0000.bmp",default_palette);
  atak_polnoc_zachod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0001.bmp",default_palette);
  atak_polnoc_zachod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0002.bmp",default_palette);
  atak_polnoc_zachod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0003.bmp",default_palette);
  atak_polnoc_zachod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0004.bmp",default_palette);
  atak_polnoc_zachod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0005.bmp",default_palette);
  atak_polnoc_zachod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0006.bmp",default_palette);
  atak_polnoc_zachod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0007.bmp",default_palette);
  atak_polnoc_zachod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0008.bmp",default_palette);
  atak_polnoc_zachod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0009.bmp",default_palette);
  atak_polnoc_zachod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0010.bmp",default_palette);
  atak_polnoc_zachod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0011.bmp",default_palette);
  atak_polnoc_zachod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack nw0012.bmp",default_palette);


  atak_polnoc_wschod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0000.bmp",default_palette);
  atak_polnoc_wschod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0001.bmp",default_palette);
  atak_polnoc_wschod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0002.bmp",default_palette);
  atak_polnoc_wschod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0003.bmp",default_palette);
  atak_polnoc_wschod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0004.bmp",default_palette);
  atak_polnoc_wschod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0005.bmp",default_palette);
  atak_polnoc_wschod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0006.bmp",default_palette);
  atak_polnoc_wschod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0007.bmp",default_palette);
  atak_polnoc_wschod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0008.bmp",default_palette);
  atak_polnoc_wschod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0009.bmp",default_palette);
  atak_polnoc_wschod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0010.bmp",default_palette);
  atak_polnoc_wschod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0011.bmp",default_palette);
  atak_polnoc_wschod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack ne0012.bmp",default_palette);


  atak_poludnie_wschod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0000.bmp",default_palette);
  atak_poludnie_wschod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0001.bmp",default_palette);
  atak_poludnie_wschod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0002.bmp",default_palette);
  atak_poludnie_wschod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0003.bmp",default_palette);
  atak_poludnie_wschod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0004.bmp",default_palette);
  atak_poludnie_wschod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0005.bmp",default_palette);
  atak_poludnie_wschod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0006.bmp",default_palette);
  atak_poludnie_wschod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0007.bmp",default_palette);
  atak_poludnie_wschod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0008.bmp",default_palette);
  atak_poludnie_wschod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0009.bmp",default_palette);
  atak_poludnie_wschod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0010.bmp",default_palette);
  atak_poludnie_wschod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0011.bmp",default_palette);
  atak_poludnie_wschod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack se0012.bmp",default_palette);


  atak_poludnie_zachod_0 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0000.bmp",default_palette);
  atak_poludnie_zachod_1 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0001.bmp",default_palette);
  atak_poludnie_zachod_2 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0002.bmp",default_palette);
  atak_poludnie_zachod_3 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0003.bmp",default_palette);
  atak_poludnie_zachod_4 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0004.bmp",default_palette);
  atak_poludnie_zachod_5 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0005.bmp",default_palette);
  atak_poludnie_zachod_6 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0006.bmp",default_palette);
  atak_poludnie_zachod_7 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0007.bmp",default_palette);
  atak_poludnie_zachod_8 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0008.bmp",default_palette);
  atak_poludnie_zachod_9 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0009.bmp",default_palette);
  atak_poludnie_zachod_10 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0010.bmp",default_palette);
  atak_poludnie_zachod_11 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0011.bmp",default_palette);
  atak_poludnie_zachod_12 = load_bmp("./T green knight/green knight battlefield bitmaps/attack sw0012.bmp",default_palette);


	}

// ################################################################################# destruktor:

    // Destruktor jest funkcją uruchamianą podczas "pozbycia" się klasy.

	~Rycerz()
	{

	}

// #################################################################################

	void zmiana_pozycji()
	{
		
		if(poz_x < punkt_docelowy_x)
		{
			poz_x += 1;
		}
		
		if(poz_x > punkt_docelowy_x)
		{
			poz_x -= 1;
		}
		
		if(poz_y < punkt_docelowy_y)
		{
			poz_y += 1;
		}
		
		if(poz_y > punkt_docelowy_y)
		{
			poz_y -= 1;
		}
	}
	
	void nastepna_pozycja(int poz_mx, int poz_my)
	{
		
		if(wybrany == 1)
		{
			punkt_docelowy_x = poz_mx;
			punkt_docelowy_y = poz_my;
		}
		
		next_poz_x = poz_x;
		next_poz_y = poz_y;
				
		if(poz_x < punkt_docelowy_x)
		{
			next_poz_x += 1;
		}
		
		if(poz_x > punkt_docelowy_x)
		{
			next_poz_x -= 1;
		}
		
		if(poz_y < punkt_docelowy_y)
		{
			next_poz_y += 1;
		}
		
		if(poz_y > punkt_docelowy_y)
		{
			next_poz_y -= 1;
		}
	}

	
	void draw(BITMAP *bufor, int time, int frame, int mx, int my, int mx_old, int my_old)
	{
		if(pozwolenie_na_marsz == 0)
		{
			zmiana_pozycji();
		}
		else
		{
			if(((punkt_docelowy_x-poz_x) != 0)||((punkt_docelowy_y-poz_y) != 0))
			{
				nie_wykonano_zmiany_pozycji = 1;
			}
			
		}

		x = poz_x - 48;
		y = poz_y - 48;

		if(kierunek == 1)	atak_polnoc(bufor, time , frame);
		if(kierunek == 2)	atak_polnoc_wchod(bufor, time , frame);
		if(kierunek == 3)	atak_wschod(bufor, time , frame);
		if(kierunek == 4)	atak_poludnie_wschod(bufor, time , frame);
		if(kierunek == 5)	atak_poludnie(bufor, time , frame);
		if(kierunek == 6)	atak_poludnie_zachod(bufor, time , frame);;
		if(kierunek == 7)	atak_zachod(bufor, time , frame);
		if(kierunek == 8)	atak_polnoc_zachod(bufor, time , frame);

		if((poz_x > mx)&&(poz_x < mx_old)&&(poz_y>my)&&(poz_y<my_old))
		{
			wybrany = 1;
		}

		if(wybrany == 1)
		{
			line(bufor, x+20, y+20, x+80, y+20, makecol(255,255,255));
			line(bufor, x+20, y+80, x+80, y+80, makecol(255,255,255));
			line(bufor, x+20, y+20, x+20, y+80, makecol(255,255,255));
			line(bufor, x+80, y+20, x+80, y+80, makecol(255,255,255));
		}

	}

	void atak_wschod(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_wschod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_wschod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_wschod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_wschod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_wschod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_wschod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_wschod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_wschod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_wschod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_wschod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_wschod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_wschod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_wschod_12, x, y); }


	}

	void atak_polnoc(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_polnoc_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_polnoc_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_polnoc_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_polnoc_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_polnoc_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_polnoc_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_polnoc_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_polnoc_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_polnoc_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_polnoc_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_polnoc_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_polnoc_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_polnoc_12, x, y); }


	}

	void atak_poludnie(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_poludnie_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_poludnie_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_poludnie_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_poludnie_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_poludnie_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_poludnie_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_poludnie_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_poludnie_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_poludnie_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_poludnie_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_poludnie_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_poludnie_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_poludnie_12, x, y); }


	}

	void atak_zachod(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_zachod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_zachod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_zachod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_zachod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_zachod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_zachod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_zachod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_zachod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_zachod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_zachod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_zachod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_zachod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_zachod_12, x, y); }


	}


	void atak_poludnie_zachod(BITMAP *bufor, int time, int frame)
	{

		if( frame<time) { draw_sprite(bufor, atak_poludnie_zachod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_poludnie_zachod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_poludnie_zachod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_poludnie_zachod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_poludnie_zachod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_poludnie_zachod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_poludnie_zachod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_poludnie_zachod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_poludnie_zachod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_poludnie_zachod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_poludnie_zachod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_poludnie_zachod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_poludnie_zachod_12, x, y); }



	}

	void atak_polnoc_zachod(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_polnoc_zachod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_polnoc_zachod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_polnoc_zachod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_polnoc_zachod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_polnoc_zachod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_polnoc_zachod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_polnoc_zachod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_polnoc_zachod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_polnoc_zachod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_polnoc_zachod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_polnoc_zachod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_polnoc_zachod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_polnoc_zachod_12, x, y); }


	}

	void atak_poludnie_wschod(BITMAP *bufor, int time, int frame)
	{

		if( frame<time) { draw_sprite(bufor, atak_poludnie_wschod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_poludnie_wschod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_poludnie_wschod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_poludnie_wschod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_poludnie_wschod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_poludnie_wschod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_poludnie_wschod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_poludnie_wschod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_poludnie_wschod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_poludnie_wschod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_poludnie_wschod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_poludnie_wschod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_poludnie_wschod_12, x, y); }



	}

	void atak_polnoc_wchod(BITMAP *bufor, int time, int frame)
	{


		if( frame<time) { draw_sprite(bufor, atak_polnoc_wschod_0, x, y);}
		else if( frame>=10 && frame<20) { draw_sprite(bufor, atak_polnoc_wschod_1, x, y); }
		else if( frame>=20 && frame<30) { draw_sprite(bufor, atak_polnoc_wschod_2, x, y); }
		else if( frame>=30 && frame<40) { draw_sprite(bufor, atak_polnoc_wschod_3, x, y); }
		else if( frame>=40 && frame<50) { draw_sprite(bufor, atak_polnoc_wschod_4, x, y); }
		else if( frame>=50 && frame<60) { draw_sprite(bufor, atak_polnoc_wschod_5, x, y); }
		else if( frame>=60 && frame<70) { draw_sprite(bufor, atak_polnoc_wschod_6, x, y); }
		else if( frame>=70 && frame<80) { draw_sprite(bufor, atak_polnoc_wschod_7, x, y); }
		else if( frame>=80 && frame<90) { draw_sprite(bufor, atak_polnoc_wschod_8, x, y); }
		else if( frame>=90 && frame<100) { draw_sprite(bufor, atak_polnoc_wschod_9, x, y); }
		else if( frame>=100 && frame<110) { draw_sprite(bufor, atak_polnoc_wschod_10, x, y); }
		else if( frame>=110 && frame<120) { draw_sprite(bufor, atak_polnoc_wschod_11, x, y); }
		else if( frame>=120 && frame<130) { draw_sprite(bufor, atak_polnoc_wschod_12, x, y); }


	}

// #################################################################################

	void idz(int poz_mx, int poz_my)
	{
		
		double d;
		double roznica_x;
		double roznica_y;
		
		if(wybrany == 1)
		{
			punkt_docelowy_x = poz_mx;
			punkt_docelowy_y = poz_my;
			
			roznica_x = punkt_docelowy_x - poz_x;
			roznica_y = punkt_docelowy_y - poz_y;
			
			//d = sqrt(pow(abs(poz_x - punkt_docelowy_x), 2)+pow(abs(poz_y - punkt_docelowy_y), 2));
			
			if(roznica_x > 0)
			{
				if(roznica_y < 0)
				{
					if(abs(roznica_y/roznica_x) > 1)
					{
						kierunek = 1;
					}
					else
					{
						kierunek = 2;
					}
				}
				else
				{
					if(abs(roznica_y/roznica_x) > 1)
					{
						kierunek = 4;
					}
					else
					{
						kierunek = 3;
					}
				}
			}
			else
			{
				if(roznica_y < 0)
				{
					if(abs(roznica_y/roznica_x) > 1)
					{
						kierunek = 1;
					}
					else
					{
						kierunek = 7;
					}
				}
				else
				{
					if(abs(roznica_y/roznica_x) > 1)
					{
						kierunek = 5;
					}
					else
					{
						kierunek = 6;
					}
				}
			}
				
		}
		
	}

};
